<!DOCTYPE html>
<!--
 *  Copyright (c) 2015 The WebRTC project authors. All Rights Reserved.
 *
 *  Use of this source code is governed by a BSD-style license
 *  that can be found in the LICENSE file in the root of the source
 *  tree.
-->
<html>
<head>

<meta charset="utf-8">
<meta name="description" content="WebRTC code samples">
<meta name="viewport" content="width=device-width, user-scalable=yes, initial-scale=1, maximum-scale=1">
<meta itemprop="description" content="Client-side WebRTC code samples">
<meta itemprop="image" content="../../../images/webrtc-icon-192x192.png">
<meta itemprop="name" content="WebRTC code samples">
<meta name="mobile-web-app-capable" content="yes">
<meta id="theme-color" name="theme-color" content="#ffffff">

<base target="_blank">

<title>Peer connection</title>


</head>

<body>

	<div id="container">


	<video id="localVideo" autoplay muted></video>
	<video id="remoteVideo" autoplay></video>


    <p>View the console to see logging. The <code>MediaStream</code> object <code>localStream</code>, and the <code>RTCPeerConnection</code> objects <code>pc1</code> and <code>pc2</code> are in global scope, so you can inspect them in the console as well.</p>

    <p>For more information about RTCPeerConnection, see <a href="http://www.html5rocks.com/en/tutorials/webrtc/basics/" title="HTML5 Rocks article about WebRTC by Sam Dutton">Getting Started With WebRTC</a>.</p>


	</div>

	<script src="https://webrtc.github.io/adapter/adapter-latest.js"></script>

	<script>
  
  /*
   *  Copyright (c) 2015 The WebRTC project authors. All Rights Reserved.
   *
   *  Use of this source code is governed by a BSD-style license
   *  that can be found in the LICENSE file in the root of the source
   *  tree.
   */


  
  // ======================= UI elements =======================

  
  var localVideo = document.getElementById('localVideo');
  var remoteVideo = document.getElementById('remoteVideo');


  // ======================= Streaming =======================

  var localStream;
  var pc1;
  var pc2;


  function hangup() {
    console.log('Ending call');
    pc1.close();
    pc2.close();
    pc1 = null;
    pc2 = null;
  }
  
  function start() {
    console.log('Requesting local stream');
    navigator.mediaDevices.getUserMedia({
      audio: true,
      video: false
    })
    .then(
    	  function(stream) {
    	    console.log('Received local stream');
    	    
    	    localVideo.srcObject = stream;
    	    localStream = stream;
    	    
    	  }
    	  
    	  ,call
    	  
    )
    .catch(function(e) {
      alert('getUserMedia() error: ' + e.name);
    });
  }
    
  

  function call() {
    console.log('Starting call');

    //     var videoTracks = localStream.getVideoTracks();
    var audioTracks = localStream.getAudioTracks();
    
    if (videoTracks.length > 0) {
      console.log('Using video device: ' + videoTracks[0].label);
    }
    if (audioTracks.length > 0) {
      console.log('Using audio device: ' + audioTracks[0].label);
    }
    
    var servers = null;
    pc1 = new RTCPeerConnection(servers);
    console.log('Created local peer connection object pc1');
    pc1.onicecandidate = function(e) {
      onIceCandidate(pc1, e);
    };
    
    pc1.oniceconnectionstatechange = function(event) {
      if (pc1) {
        console.log(' ICE state: ' + pc1.iceConnectionState);
        console.log('ICE state change event: ', event);
      }
    };
  
  	 console.log('pc1 createOffer start');
  	 pc1.createOffer(
  	       {   offerToReceiveAudio: 1,  offerToReceiveVideo: 1 }
  	 ).then(
  	    
			  function(desc) {
			    console.log('Offer from pc1\n' + desc.sdp);
			    console.log('pc1 setLocalDescription start');
			    pc1.setLocalDescription(desc).then(
			      function() {
			         console.log(' setLocalDescription complete');
			      },
			      function(error){
			      	console.log('Failed to set session description: ' + error.toString());
			      }
			    );
			    
			    
			    console.log('pc2 setRemoteDescription start');
			    pc2.setRemoteDescription(desc).then(
			      function() {
			      	console.log(' setRemoteDescription complete');
			      },
			      function(error){
			      	console.log('Failed to set session description: ' + error.toString());
			      }
			    );
			    console.log('pc2 createAnswer start');
			    
			    // Since the 'remote' side has no media stream we need
			    // to pass in the right constraints in order for it to
			    // accept the incoming offer of audio and video.
			    pc2.createAnswer().then(
			      
			  	  function(desc) {
			  	    console.log('Answer from pc2:\n' + desc.sdp);
			  	    console.log('pc2 setLocalDescription start');
			  	    pc2.setLocalDescription(desc).then(
			  	      function() {
			  	          console.log(' setLocalDescription complete');
			  	      },
			  	      function(error){
			  	      	console.log('Failed to set session description: ' + error.toString());
			  	      }
			  	    );
			  	    console.log('pc1 setRemoteDescription start');
			  	    
			  	    
			  	    
			  	    pc1.setRemoteDescription(desc).then(
			  	      function() {
			  	      	console.log(' setRemoteDescription complete');
			  	      },
			  	      function(error){
			  	      	console.log('Failed to set session description: ' + error.toString());
			  	      }
			  	    );
			  	  }
			     ,function(error) {
				       console.log('Failed to create session description: ' + error.toString());
				  }
			    );
			  }

  			 
  		,function(error) {
  	      console.log('Failed to create session description: ' + error.toString());
  	   }
  	
  	 );
  	 console.log('Added local stream to pc1');

    
    
    
    
    pc2 = new RTCPeerConnection(servers);
    console.log('Created remote peer connection object pc2');
    pc2.onicecandidate = function(e) {
      onIceCandidate(pc2, e);
    };
    
	 pc2.oniceconnectionstatechange = function(e) {
    		if (pc2) {
      	console.log(' ICE state: ' + pc2.iceConnectionState);
      	console.log('ICE state change event: ', event);
    	}
  	 };
	 pc2.ontrack =  function(e) {
	    if (remoteVideo.srcObject !== e.streams[0]) {
	      remoteVideo.srcObject = e.streams[0];
	      console.log('pc2 received remote stream');
	    }
	 };
	
	 localStream.getTracks().forEach(
	    function(track) {
	      pc1.addTrack( track,localStream );
	    }
	 );
	
    
  }

  
  // =============================== Stupid shit ===============================



  function onIceCandidate(pc, event) {
  	
  	 ((pc === pc1) ? pc2 : pc1)
    .addIceCandidate(event.candidate)
    .then(
      function() {
         console.log(' addIceCandidate success');
      },
      function(err) {
         console.log(' failed to add ICE Candidate: ' + error.toString());
      }
    );
    console.log(' ICE candidate: \n' + (event.candidate ? event.candidate.candidate : '(null)'));
  }


  
  start();


  
  </script>

</body>
</html>

